 /* Websphere MQ Client - Connects and sends or receives messages  from WebSphere (IBM) Application Server
  * WebSphere is Copyright IBM 
    Copyright (C) 2012  David Welford-Costelloe (http://www.welford-costelloe.org)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package com.ca.on.burlington.base.classes;

import java.net.InetAddress;
import java.net.UnknownHostException;

/**
 * @author dwelford
 * 
 */
public class UtilsClass {

	private String ipAddress = null;
	private String localMachineName = null;

	/**
	 * @return the ipAddress
	 */
	public String getIpAddress() {
		return ipAddress;
	}

	/**
	 * @return the localMachineName
	 */
	public String getLocalMachineName() {
		return localMachineName;
	}

	/**
	 * 
	 */
	public UtilsClass() {
		this.ipAddress = getComputerIP();
		this.localMachineName = getComputerName();

	}

	/**
	 * Get current computer IP address
	 * 
	 * @return Return IP Address
	 */
	private String getComputerIP() {
		String ipAddress = null;
		try {
			InetAddress inetAddress = InetAddress.getLocalHost();
			ipAddress = inetAddress.getHostAddress();
		} catch (UnknownHostException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return ipAddress;
	}

	/**
	 * Get the current computer name
	 * 
	 * @return Returns the name of the current computer
	 */
	private String getComputerName() {
		String computername = null;
		try {
			computername = InetAddress.getLocalHost().getHostName();
		} catch (UnknownHostException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		System.out.println(computername);
		return computername;
	}

}
