 /* Websphere MQ Client - Connects and sends or receives messages  from WebSphere (IBM) Application Server
  * WebSphere is Copyright IBM 
    Copyright (C) 2012  David Welford-Costelloe (http://www.welford-costelloe.org)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package com.ca.on.burlington.base.forms;

import java.awt.Color;
import java.awt.Font;
import java.awt.Panel;
import java.awt.Rectangle;
import java.awt.Scrollbar;
import java.awt.TextArea;
import java.awt.TextField;
import java.awt.Toolkit;
import java.awt.event.KeyEvent;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.SwingUtilities;

import com.ca.on.burlington.base.classes.PropertiesClass;
import com.ca.on.burlington.base.classes.UtilsClass;
import com.ibm.mq.MQC;
import com.ibm.mq.MQEnvironment;
import com.ibm.mq.MQException;
import com.ibm.mq.MQGetMessageOptions;
import com.ibm.mq.MQMessage;
import com.ibm.mq.MQPutMessageOptions;
import com.ibm.mq.MQQueue;
import com.ibm.mq.MQQueueManager;
import javax.swing.ImageIcon;
import javax.swing.SwingConstants;
import javax.swing.JTextPane;
import javax.swing.JTable;
import javax.swing.JScrollBar;
import javax.swing.border.EtchedBorder;
import javax.swing.UIManager;
import org.openswing.swing.client.ImagePanel;
import java.awt.BorderLayout;

/**
 * @author David Welford-Costelloe
 * 
 */
public class FRMMain extends JFrame {

	private static final long serialVersionUID = 1L;
	private JPanel jContentPane = null;
	/**
	 * Variables
	 */

	private JLabel jLabel11 = null;
	private TextArea textAreaResults = null;
	private JLabel jLabel111 = null;
	private TextField textRequestQManagerName = null;
	private TextField textRequestQueueName = null;
	private JLabel jLabel112 = null;
	private Panel panel = null;
	private JLabel jLabel = null;
	private TextField textFieldHostName = null;
	private JLabel jLabel1 = null;
	private TextField textFieldChannleName = null;
	private Panel panel1 = null;
	private JLabel jLabel113 = null;
	private TextField textReplyQueueName = null;
	private JLabel jLabel1111 = null;
	private Scrollbar scrollbar = null;
	private TextField textFieldPort = null;
	private JLabel jLabel1112 = null;
	private TextField textReplyQManager = null;
	private JButton jButtonSend = null;
	private JButton jBtnExit = null;
	private JButton jBtnCheckMessages = null;
	private JCheckBox jChkDuelQueues = null;
	private JCheckBox jChkQueueManager = null;
	private Font errorFont = new Font("Verdana", Font.ITALIC, 12);
	private Font regularFont = new Font("Verdana", Font.PLAIN, 12); // @jve:decl-index=0:
	private MQQueueManager requestQMgr;
	private MQQueueManager replyQMgr;
	private UtilsClass utils = new UtilsClass();
	private MQQueue requestQueue = null;
	private MQQueue replyQueue = null;
	private List<PropertiesClass> arList = new ArrayList<PropertiesClass>(); // @jve:decl-index=0:
	private JButton jBtnClearResults = null;
	private JScrollPane jScrollPane = null;
	private JTextArea textAreaMessage = null;
	private JLabel wIcon;

	/**
	 * This method initializes textAreaResults
	 * 
	 * @return java.awt.TextArea
	 */
	private TextArea getTextAreaResults() {
		if (textAreaResults == null) {
			textAreaResults = new TextArea();
			textAreaResults.setBounds(new Rectangle(17, 554, 1135, 170)); // Generated
			textAreaResults.setEditable(false); // Generated
		}
		return textAreaResults;
	}

	/**
	 * This method initializes textRequestQManagerName
	 * 
	 * @return java.awt.TextField
	 */
	private TextField getTextRequestQManagerName() {
		if (textRequestQManagerName == null) {
			textRequestQManagerName = new TextField();
			textRequestQManagerName.setBounds(new Rectangle(12, 125, 527, 25)); // Generated
		}
		return textRequestQManagerName;
	}

	/**
	 * This method initializes textRequestQueueName
	 * 
	 * @return java.awt.TextField
	 */
	private TextField getTextRequestQueueName() {
		if (textRequestQueueName == null) {
			textRequestQueueName = new TextField();
			textRequestQueueName.setBounds(new Rectangle(6, 28, 527, 25)); // Generated
		}
		return textRequestQueueName;
	}

	/**
	 * This method initializes panel
	 * 
	 * @return java.awt.Panel
	 */
	private Panel getPanel() {
		if (panel == null) {
			jLabel1112 = new JLabel();
			jLabel1112.setBounds(new Rectangle(13, 154, 172, 17)); // Generated
			jLabel1112.setText("Enter Reply QManager Name:"); // Generated
			jLabel1112
					.setToolTipText("Enter the name of the QManage to connect to"); // Generated
			jLabel1111 = new JLabel();
			jLabel1111.setText("Select the port number"); // Generated
			jLabel1111.setBounds(new Rectangle(10, 117, 159, 21)); // Generated
			jLabel1111.setToolTipText(""); // Generated
			jLabel1 = new JLabel();
			jLabel1.setBounds(new Rectangle(12, 63, 151, 17)); // Generated
			jLabel1.setText("Enter Channel Name:"); // Generated

			jLabel = new JLabel();
			jLabel.setToolTipText("Enter the name of the Host"); // Generated
			jLabel.setBounds(new Rectangle(12, 9, 101, 16)); // Generated
			jLabel.setText("Enter Host Name:"); // Generated
			panel = new Panel();
			panel.setLayout(null); // Generated
			panel.setBounds(new Rectangle(12, 11, 557, 208)); // Generated
			panel.add(getTextFieldHostName(), null); // Generated
			panel.add(jLabel, null); // Generated
			panel.add(jLabel1, null); // Generated
			panel.add(getTextFieldChannleName(), null); // Generated
			panel.add(getTextRequestQManagerName(), null); // Generated
			panel.add(jLabel111, null); // Generated
			panel.add(jLabel1112, null); // Generated
			panel.add(getTextReplyQManager(), null); // Generated
			panel.add(getJChkQueueManager(), null); // Generated
		}
		return panel;
	}

	/**
	 * This method initializes textFieldHostName
	 * 
	 * @return java.awt.TextField
	 */
	private TextField getTextFieldHostName() {
		if (textFieldHostName == null) {
			textFieldHostName = new TextField();
			textFieldHostName.setBounds(new Rectangle(12, 28, 527, 25)); // Generated
		}
		return textFieldHostName;
	}

	/**
	 * This method initializes textFieldChannleName
	 * 
	 * @return java.awt.TextField
	 */
	private TextField getTextFieldChannleName() {
		if (textFieldChannleName == null) {
			textFieldChannleName = new TextField();
			textFieldChannleName.setBounds(new Rectangle(12, 80, 527, 25)); // Generated
		}
		return textFieldChannleName;
	}

	/**
	 * This method initializes panel1
	 * 
	 * @return java.awt.Panel
	 * @throws IOException 
	 */
	private Panel getPanel1() throws IOException {
		if (panel1 == null) {
			jLabel113 = new JLabel();
			jLabel113.setBounds(new Rectangle(10, 60, 223, 23)); // Generated
			jLabel113.setText("Enter the Queue Name to Listen to "); // Generated
			jLabel113.setToolTipText(""); // Generated
			panel1 = new Panel();
			panel1.setLayout(null); // Generated
			panel1.setBounds(new Rectangle(588, 15, 557, 200)); // Generated
			panel1.add(jLabel11, null); // Generated
			panel1.add(getTextRequestQueueName(), null); // Generated
			panel1.add(jLabel113, null); // Generated
			panel1.add(getTextReplyQueueName(), null); // Generated
			panel1.add(jLabel1111, null); // Generated
			panel1.add(getScrollbar(), null); // Generated
			panel1.add(getTextFieldPort(), null); // Generated
			panel1.add(getJChkDuelQueues(), null);
			
			ImagePanel imagePanel = new ImagePanel();
			BorderLayout borderLayout = (BorderLayout) imagePanel.getLayout();
			borderLayout.setVgap(1);
			borderLayout.setHgap(1);
			imagePanel.setToolTipText("GNU Free Software");
			imagePanel.setImageName("");
			imagePanel.setImage(Toolkit.getDefaultToolkit().getImage(FRMMain.class.getResource("/com/ca/on/burlington/base/images/gplv3-127x51.png")));
			imagePanel.setBounds(361, 120, 172, 62);
			panel1.add(imagePanel);
			ImageIcon image = new ImageIcon(FRMMain.class.getResource("/com/ca/on/burlington/base/images/gplv3-127x51.png"));
			
			//ImageIcon image = new ImageIcon(FRMMain.class.getResource("/com/ca/on/burlington/base/images/gplv3-127x51.png"));
		}
		return panel1;
	}

	/**
	 * This method initializes textReplyQueueName
	 * 
	 * @return java.awt.TextField
	 */
	private TextField getTextReplyQueueName() {
		if (textReplyQueueName == null) {
			textReplyQueueName = new TextField();
			textReplyQueueName.setBounds(new Rectangle(10, 85, 528, 23)); // Generated
		}
		return textReplyQueueName;
	}

	/**
	 * This method initializes scrollbar
	 * 
	 * @return java.awt.Scrollbar
	 */
	private Scrollbar getScrollbar() {
		if (scrollbar == null) {
			scrollbar = new Scrollbar();
			scrollbar.setValue(1420); // Generated
			scrollbar.setOrientation(Scrollbar.HORIZONTAL); // Generated
			scrollbar.setVisibleAmount(10); // Generated
			scrollbar.setBounds(new Rectangle(19, 143, 165, 39)); // Generated
			scrollbar.setMaximum(9999); // Generated
			scrollbar
					.addAdjustmentListener(new java.awt.event.AdjustmentListener() {
						public void adjustmentValueChanged(
								java.awt.event.AdjustmentEvent e) {
							int val = scrollbar.getValue();
							textFieldPort.setText(String.valueOf(val));

						}

					});
		}
		return scrollbar;
	}

	/**
	 * This method initializes textFieldPort
	 * 
	 * @return java.awt.TextField
	 */
	private TextField getTextFieldPort() {
		if (textFieldPort == null) {
			textFieldPort = new TextField();
			textFieldPort.setEditable(false); // Generated
			textFieldPort.setBounds(new Rectangle(204, 149, 139, 24)); // Generated
		}
		return textFieldPort;
	}

	/**
	 * This method initializes textReplyQManager
	 * 
	 * @return java.awt.TextField
	 */
	private TextField getTextReplyQManager() {
		if (textReplyQManager == null) {
			textReplyQManager = new TextField();
			textReplyQManager.setBounds(new Rectangle(12, 173, 532, 24)); // Generated
		}
		return textReplyQManager;
	}

	/**
	 * This method initializes jButtonSend
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonSend() {
		if (jButtonSend == null) {
			jButtonSend = new JButton();
			jButtonSend.setBounds(new Rectangle(18, 770, 123, 32)); // Generated
			jButtonSend.setText("Send Message"); // Generated
			jButtonSend
					.setToolTipText("Click to send a message to Websphere MQ"); // Generated
			jButtonSend.setEnabled(false); // Generated
			jButtonSend.setMnemonic(KeyEvent.VK_S); // Generated
			jButtonSend.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					StringBuffer sb = new StringBuffer();
					init();
					System.out.println("arLidt : " + arList.toString());
					for (PropertiesClass oList : arList) {
						oList.setPortNum(Integer.parseInt(textFieldPort
								.getText()));
						sb.append("Host: [" + oList.getHostName() + "]\n");
						sb
								.append("Port Number: [" + oList.getPortNum()
										+ "]\n");
						sb
								.append("Channel: [" + oList.getChannelName()
										+ "]\n");
						sb.append("Queue Manager ["
								+ oList.getRequestQManager() + "]\n");
						sb.append("Queue Name: [" + oList.getRequestQueueName()
								+ "]");
					}
					// Make sure required fields are checked
					if (checkInputs(true)) {

						sendYesNoDialog(sb, "Confirm Parameters");

					}
				}
			});
		}
		return jButtonSend;
	}

	/**
	 * This method initializes jBtnExit
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJBtnExit() {
		if (jBtnExit == null) {
			jBtnExit = new JButton();
			jBtnExit.setBounds(new Rectangle(1022, 773, 120, 26)); // Generated
			jBtnExit.setText("Exit"); // Generated
			jBtnExit.setToolTipText("Click to Exit Application"); // Generated
			jBtnExit.setMnemonic(KeyEvent.VK_X); // Generated
			jBtnExit.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					exitApplication();
				}
			});
		}
		return jBtnExit;
	}

	/**
	 * This method initializes jBtnCheckMessages
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJBtnCheckMessages() {
		if (jBtnCheckMessages == null) {
			jBtnCheckMessages = new JButton();
			jBtnCheckMessages.setBounds(new Rectangle(271, 775, 156, 25)); // Generated
			jBtnCheckMessages.setText("Check for Messages"); // Generated
			jBtnCheckMessages.setToolTipText("Click to check for messages"); // Generated
			jBtnCheckMessages.setEnabled(true); // Generated
			jBtnCheckMessages.setMnemonic(KeyEvent.VK_E); // Generated
			jBtnCheckMessages
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							String sHold = "Socket connection attempt refused";
							String sMsg = null;
							// Only need to check reading
							if (checkInputs(false)) {

								init();
								try {
									readMQ();
								} catch (MQException e1) {
									for (PropertiesClass oList : arList) {

										sMsg = "MQException with Queue: Unable to connect to WMQ. Check your configuration and try again "
												+ e1.toString()
												+ " Host: ["
												+ oList.getHostName()
												+ "] Port: ["
												+ oList.getPortNum() + "]";
									}
									if (e1.getMessage().contains(sHold)) {
										setFonts(true, sMsg);

									} else {
										String strMsg = "MQException with Queue "
												+ e1.getMessage();
										setFonts(true, strMsg);

									}

								}
							}
						}

					});
		}
		return jBtnCheckMessages;
	}

	/**
	 * This method initializes jChkDuelQueues
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private JCheckBox getJChkDuelQueues() {
		if (jChkDuelQueues == null) {
			jChkDuelQueues = new JCheckBox();
			jChkDuelQueues.setBounds(new Rectangle(295, 57, 241, 21)); // Generated
			jChkDuelQueues.setText("Listen Queue same as Send Queue"); // Generated
			jChkDuelQueues
					.setToolTipText("Check to duplicate Send Queue to Listen Queue"); // Generated
			jChkDuelQueues.setMnemonic(KeyEvent.VK_Q); // Generated
			jChkDuelQueues
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							if (jChkDuelQueues.isSelected()) {
								textReplyQueueName.setText(textRequestQueueName
										.getText());
								textReplyQueueName.setEnabled(false);

							} else {
								textReplyQueueName.setEnabled(true);
								textReplyQueueName.setText(null);
								textReplyQueueName.requestFocus();
							}
						}
					});
		}
		return jChkDuelQueues;
	}

	/**
	 * This method initializes jChkQueueManager
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private JCheckBox getJChkQueueManager() {
		if (jChkQueueManager == null) {
			jChkQueueManager = new JCheckBox();
			jChkQueueManager.setBounds(new Rectangle(299, 148, 237, 27)); // Generated
			jChkQueueManager
					.setToolTipText("Check if you want to use the same Queue name as Request Queue"); // Generated
			jChkQueueManager.setText("Use Request Queue Name"); // Generated
			jChkQueueManager
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							if (jChkQueueManager.isSelected()) {
								textReplyQManager
										.setText(textRequestQManagerName
												.getText());
								textReplyQManager.setEnabled(false);
							} else {
								textReplyQManager.setText(null);
								textReplyQManager.setEnabled(true);
								textReplyQManager.requestFocus();
							}
						}
					});
		}
		return jChkQueueManager;
	}

	/**
	 * This method initializes jBtnClearResults
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJBtnClearResults() {
		if (jBtnClearResults == null) {
			jBtnClearResults = new JButton();
			jBtnClearResults.setBounds(new Rectangle(662, 777, 163, 24)); // Generated
			jBtnClearResults.setText("Clear Results"); // Generated
			jBtnClearResults.setToolTipText("Click to clear the results pane"); // Generated
			jBtnClearResults.setMnemonic(KeyEvent.VK_L); // Generated
			jBtnClearResults
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							textAreaResults.setText("");
						}
					});
		}
		return jBtnClearResults;
	}

	/**
	 * This method initializes jScrollPane
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setBounds(new Rectangle(16, 228, 1125, 284)); // Generated
			jScrollPane.setViewportView(getTextAreaMessage()); // Generated

		}
		return jScrollPane;
	}

	/**
	 * This method initializes textAreaMessage
	 * 
	 * @return javax.swing.JTextArea
	 */
	private JTextArea getTextAreaMessage() {
		if (textAreaMessage == null) {
			textAreaMessage = new JTextArea();
			textAreaMessage.addKeyListener(new java.awt.event.KeyAdapter() {
				public void keyTyped(java.awt.event.KeyEvent e) {
					jButtonSend
							.setEnabled(textAreaMessage.getText().length() > 0);
				}
			});
		}
		return textAreaMessage;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				FRMMain thisClass = new FRMMain();
				thisClass.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
				thisClass.setVisible(true);
			}
		});

	}

	/**
	 * This is the default constructor
	 */
	public FRMMain() {
		super();
		initialize();
		this.textFieldHostName.setText(utils.getLocalMachineName());
		// My Test Case
		testDavid();
			
		}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(1182, 866);
		this.setIconImage(Toolkit.getDefaultToolkit().getImage(
				getClass().getResource(
						"/com/ca/on/burlington/base/images/office5_32.png"))); // Generated
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE); // Generated
		this.setContentPane(getJContentPane());
		this.setTitle("WebSphere MQ Messenger");
		this.setLocationRelativeTo(null);

	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel112 = new JLabel();
			jLabel112.setBounds(new Rectangle(12, 530, 1127, 19)); // Generated
			jLabel112.setText("Results back from Websphere MQ"); // Generated
			jLabel112.setToolTipText(""); // Generated
			jLabel111 = new JLabel();
			jLabel111.setText("Enter Request QManager Name:"); // Generated
			jLabel111.setBounds(new Rectangle(12, 106, 222, 16)); // Generated
			jLabel111
					.setToolTipText("Enter the name of the QManage to connect to"); // Generated
			jLabel11 = new JLabel();
			jLabel11.setText("Enter the Queue Name to send the message"); // Generated
			jLabel11.setBounds(new Rectangle(5, 5, 506, 16)); // Generated
			jLabel11.setToolTipText(""); // Generated
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(getTextAreaResults(), null); // Generated
			jContentPane.add(jLabel112, null); // Generated
			jContentPane.add(getPanel(), null); // Generated
			jContentPane.add(getPanel1(), null); // Generated
			jContentPane.add(getJButtonSend(), null); // Generated
			jContentPane.add(getJBtnExit(), null); // Generated
			jContentPane.add(getJBtnCheckMessages(), null); // Generated
			jContentPane.add(getJBtnClearResults(), null); // Generated
			jContentPane.add(getJScrollPane(), null);
		}
		return jContentPane;
	}

	/***
	 * Initialize Variables and set arrayList of PropertiesClass
	 */
	@SuppressWarnings("unchecked")
	public void init() {
		PropertiesClass list = new PropertiesClass();
		arList.clear();
		// Set up MQSeries environment
		list.setHostName(this.textFieldHostName.getText());
		list.setChannelName(this.textFieldChannleName.getText());
		list.setRequestQueueName(textRequestQueueName.getText());
		list.setReplyQueueName(textReplyQueueName.getText());
		list.setReplyQManager(textReplyQManager.getText());
		list.setRequestQManager(textRequestQManagerName.getText());
		list.setPortNum(Integer.parseInt(textFieldPort.getText()));
		arList.add(list);
		for (PropertiesClass oList : arList) {
			MQEnvironment.hostname = oList.getHostName();
			MQEnvironment.channel = oList.getChannelName();
			MQEnvironment.port = oList.getPortNum();
			MQEnvironment.properties.put(MQC.TRANSPORT_PROPERTY,
					MQC.TRANSPORT_MQSERIES);

		}

	} // end of init

	/**
	 * Send Message to WMQ
	 */
	public void processRequest() {
		String sRequestManager = null;
		String sRequestQueue = null;

		for (PropertiesClass oList : arList) {
			sRequestManager = oList.getRequestQManager();
			sRequestQueue = oList.getRequestQueueName();
		}
		try {
			// Create a connection to the queue manager
			requestQMgr = new MQQueueManager(sRequestManager);

			// Set options
			int iOptions = MQC.MQOO_INPUT_AS_Q_DEF | MQC.MQOO_OUTPUT;

			// Open queue and set options
			requestQueue = requestQMgr.accessQueue(sRequestQueue, iOptions,
					null, null, null);
			// Build Message
			MQMessage send_msg = new MQMessage();
			// Get the message from the jTextArea
			send_msg.writeUTF(textAreaMessage.getText().trim());
			// Set the options
			MQPutMessageOptions pmo = new MQPutMessageOptions();
			// put the message on the queue
			requestQueue.put(send_msg, pmo);
			// Close the Queue
			requestQueue.close();
			// Disconnect from the queue manager
			requestQMgr.disconnect();
			setFonts(false, "Message has been placed on the Queue "
					+ sRequestQueue + " With Message of: "
					+ textAreaMessage.getText());

		} catch (MQException ex) {
			// MQ Error
			System.out.println("An MQSeries error occurred : Completion code "
					+ ex.completionCode + " Reason code " + ex.reasonCode);
			setFonts(true, "An MQException error: Completion code "
					+ ex.completionCode + " Reason code " + ex.reasonCode);

		}
		// Buffer Error?
		catch (java.io.IOException ex) {
			System.out
					.println("An error occurred while writing to the message buffer: "
							+ ex);
			setFonts(true,
					"An error occurred while writing to the message buffer: "
							+ ex);
		}

	} // end of start

	/***
	 * Check to ensure all required Textboxes values are set
	 * 
	 * @return Return true or false
	 */
	private boolean checkInputs(boolean blnSendMessage) {
		boolean blnCheck = true;
		// Required for Send and receive
		if (this.textFieldHostName.getText().length() == 0) {
			blnCheck = false;
			sendUserMessage("Please enter a Host Name to send to?",
					"Enter a Host Name");
			this.textFieldHostName.requestFocus();
			return blnCheck;
		}
		// Required for Send and Receive
		if (this.textFieldChannleName.getText().length() == 0) {
			blnCheck = false;
			sendUserMessage("Please enter a Channel Name to send to?",
					"Enter a Channel Name");
			this.textFieldChannleName.requestFocus();
			return blnCheck;
		}
		// Only required for Sending
		if (blnSendMessage) {
			if (this.textRequestQueueName.getText().length() == 0) {
				blnCheck = false;
				sendUserMessage(
						"Please enter a Request Queue Name to send to?",
						"Enter Post to Queue Name");
				this.textRequestQueueName.requestFocus();
				return blnCheck;
			}
		}

		// Required for Checking only
		if (blnSendMessage == false) {
			if (this.textReplyQueueName.getText().length() == 0) {
				blnCheck = false;
				sendUserMessage(
						"Please enter a Reply Queue Name to listen to?",
						"Enter a listen queue Name");
				this.textReplyQueueName.requestFocus();
				return blnCheck;
			}
		}
		// Only required for Checking messages
		if (blnSendMessage == false) {
			if (this.textReplyQManager.getText().length() == 0) {
				blnCheck = false;
				this.textReplyQManager.requestFocus();
				sendUserMessage("Please enter Reply Queue Manager?",
						"Reply Queue Manager");
				return blnCheck;
			}
		}
		// Only required for Sending messages
		if (blnSendMessage) {
			if (this.textAreaMessage.getText().length() == 0) {
				blnCheck = false;
				sendUserMessage("Please enter a message to send?",
						"Enter a Message to send");
				this.textAreaMessage.requestFocus();
				return blnCheck;
			}
		}

		return blnCheck;
	}

	/***
	 * Exit Application and confirm
	 */
	private void exitApplication() {

		if (JOptionPane.showConfirmDialog(null,
				"Are you sure you want to Exit?", "Verify Exit Request",
				JOptionPane.OK_CANCEL_OPTION) == 0) {
			System.exit(0);
		}
	}

	/***
	 * Send single JOptionPane with OK button only
	 * 
	 * @param sText
	 * @param sTitle
	 */
	private void sendUserMessage(String sText, String sTitle) {
		JOptionPane.showMessageDialog(null, sText, sTitle,
				JOptionPane.OK_OPTION);
	}

	/***
	 * Read WebSphere MQueue
	 * 
	 * @throws MQException
	 */
	public void readMQ() throws MQException {
		String sReplyManager = null;
		String sReplyQueueName = null;
		int iPort = 0;
		for (PropertiesClass oList : arList) {
			sReplyManager = oList.getReplyQManager();
			sReplyQueueName = oList.getReplyQueueName();
			iPort = oList.getPortNum();
		}
		// See this link for more information:
		// http://middleware.its.state.nc.us/middleware/Documentation/en_US/htm/csqzaw09/csqzaw092c.htm
		int iOptions = MQC.MQOO_INQUIRE + MQC.MQOO_FAIL_IF_QUIESCING
				+ MQC.MQOO_INPUT_SHARED;
		// Create MQ Queue Manager
		replyQMgr = new MQQueueManager(sReplyManager);
		// Setup Queue to look in and pass options
		replyQueue = replyQMgr.accessQueue(sReplyQueueName, iOptions, null,
				null, null);

		// Get the depth of the queue
		int iDepth = replyQueue.getCurrentDepth();
		System.out.println("Current depth: [" + iDepth + "]");
		// Here we check to see if there are any messages in the Queue
		if (iDepth == 0) {
			// Not a big deal no messages to look at
			setFonts(false, "No messages located in Queue - Current depth: ["
					+ iDepth + "] On port: [" + iPort + "]");
			return;
		}
		// Only get here if we have messages in Queue
		MQGetMessageOptions getOptions = new MQGetMessageOptions();
		// Set the Get message options
		getOptions.options = MQC.MQGMO_NO_WAIT + MQC.MQGMO_FAIL_IF_QUIESCING
				+ MQC.MQGMO_CONVERT;
		// Loop thru if there are multiple messages
		while (true) {
			// Create new MQMessage
			MQMessage replyMsg = new MQMessage();
			try {
				// Get the message from Queue
				replyQueue.get(replyMsg, getOptions);
				String msgText = "";
				// Read message and format for UTF8
				// readUTF() will sometimes return an error when using WebSphere
				// Explorer to publish a test message
				byte[] bByte = new byte[replyMsg.getMessageLength()];
				replyMsg.readFully(bByte);
				msgText = (new String(bByte)).trim();

				// Populate Results to TextArea
				setFonts(false, "Message Returned from Queue: [" + msgText
						+ "]");
				System.out.println("The message is: " + msgText);
				// Clear the messages
				replyMsg.clearMessage();
			} catch (IOException e) {
				System.out.println("IOException: during Read: " + e.toString());

				setFonts(true, "An IOException error while reading Queue: "
						+ e.toString());

				break;
			} catch (MQException e) {
				// Check if this is just telling us there are no messages left
				// in the Queue
				// Thanks to Google Search for this fix
				if (e.completionCode == 2
						&& e.reasonCode == MQException.MQRC_NO_MSG_AVAILABLE) {
					if (iDepth > 0) {
						System.out.println("All messages read.");
						setFonts(false, "All messages in Queue ["
								+ sReplyQueueName + "] have been read");
					}
				} else {
					System.out.println("MQException: " + e);

					setFonts(true, "MQException with Queue [" + sReplyQueueName
							+ "]");

				}
				break;
			}
		}
		// Clean up Queue
		replyQueue.close();
		replyQMgr.disconnect();
	}

	/***
	 * Set Font for TextArea to Red for Erros or Black for regular
	 * 
	 * @param errFont
	 * @param strMsg
	 */
	private void setFonts(boolean errFont, String strMsg) {

		if (errFont) {
			textAreaResults.setFont(errorFont);
			textAreaResults.setForeground(Color.RED);
			textAreaResults.append(strMsg + "\n");
		} else {

			textAreaResults.setFont(regularFont);
			textAreaResults.setForeground(Color.BLACK);
			textAreaResults.append(strMsg + "\n");
		}
	}

	/***
	 * Send JoptionPane for Yes or No responses
	 * 
	 * @param sMsg
	 * @param sTitle
	 */
	private void sendYesNoDialog(StringBuffer sMsg, String sTitle) {
		int response = JOptionPane.showConfirmDialog(null, sMsg.toString()
				+ "\nDo you want to continue?", sTitle,
				JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
		if (response == JOptionPane.NO_OPTION) {
			return;
		} else if (response == JOptionPane.YES_OPTION) {
			processRequest();
		} else if (response == JOptionPane.CLOSED_OPTION) {
			System.out.println("JOptionPane closed");
			return;
		}
	}

	/***
	 * Test setup for me
	 * */
	private void testDavid() {
		textFieldChannleName.setText("SERVERCHANNEL");
		textRequestQManagerName.setText("REQUESTQUEUEMAN");
		textReplyQManager.setText("REQUESTQUEUEMAN");
		textRequestQueueName.setText(textRequestQueueName.getText());
		textRequestQueueName.setText("ESB_DWC_REQ.IN");
		textReplyQueueName.setText("ESB_DWC_REQ.OUT");
		scrollbar.setValue(1420);
		textFieldPort.setText("1420");
		

	}
	public boolean getWIconVisible() {
		return wIcon.isVisible();
	}
	public void setWIconVisible(boolean visible) {
		wIcon.setVisible(visible);
	}
} // @jve:decl-index=0:visual-constraint="10,10"
